; !!! UPGRADE TO MIRC 6.12 at http://www.mirc.com/get.html !!!
; mIRC 6.12 fixes the exploit, so you don't need this unless you want to detect lamers or use other mIRC versions.

; Exploit Fix version 1.991.  Changes: Fixed an /hdel error when a user does /whois, whois logging now handles no
;   such nick response, command queue now easily allows options
; DCC EXPLOIT PROTECTION REQUIRES MIRC 6.1 OR BETTER.
; This is copyrighted.  Released under the GPL.  Send bug reports or suggestions to olathe 65 84 erler.org.
; Contributors: Olathe, TheJerk (idea for ignore -d in DebugExploitWatcher), WatchMinister (flood stopping idea),
;               Chemunga (info about new varieties of attacks and auto-kick idea).

; Usage: Load it and let the initialization routines run
;        To change the settings later, type /ExploitFixSettings
;        To open a raw window manually, type /RawWin




; *** INITIALIZATION AND SHUTDOWN SECTION ***

; -- Start protection and ask user for settings if they've never been set
on *:start:{
  if ($version >= 6.1) {
    ; Clean up mess from previous running of script
    unset %ExploitFlood
    unset %Exploit.*
    hfree -w Firewall.*

    if (%RawWindows) scid -a .RawWin
    else scid -a InvisibleProtection

    if (!%ExploitSetUp) FirewallSettings
  }
  else echo 4 -aei4 *** This version of the exploit fix will NOT protect you unless you are using mIRC version 6.1 or higher.  A future version will protect old versions of mIRC.
}

; -- Start protection when connecting to a new server
on ^*:logon:*:{
  if ($version >= 6.1) {
    if ($hget($+(Firewall., $cid))) hfree $+(Firewall., $cid)
    if (%RawWindows) .RawWin
    else InvisibleProtection
  }
}

; -- Clean up when the script exits
on *:unload:SaveFirewallData
on *:exit:SaveFirewallData

; -- Clean up when disconnecting from a server
on *:disconnect:hfree $+(Firewall., $cid)

; -- Save firewall settings and other data
alias -l SaveFirewallData if ($hget(Firewall)) hsave -bo Firewall $+($scriptdir, firewall.dat)

; -- Start to protect without a raw window (see RawWin alias for starting protection with a raw window)
alias InvisibleProtection .debug -i NUL DebugExploitWatcher




; *** EXPLOIT PROTECTION SECTION ***

; -- Watch conversation between mIRC and the server for exploits and take any immediate action necessary
alias DebugExploitWatcher {
  var %ExploitFound = $false, %Type, %Mask, %Nick, %Target
  if ($regex($1, /^<- :(([^!]*)![^@]*@[^ ]*)\s*PRIVMSG\s*(\S*)\s*:\001\s*DCC.*"(?:[^" ]*\s){32}.*$/i)) {
    var %ExploitFound = $true, %Type = DCC spaces, %Mask = $regml(1), %Nick = $regml(2), %Target = $regml(3)
    .ignore -du10 %Nick
  }
  if (%ExploitFound) .timer 1 0 ExploitHandler %Mask %Nick %Target %Type
  return $1-
}




; *** LAMER HANDLING SECTION ***

; -- Exploit-using lamer handling
alias ExploitHandler {
  var %Mask = $1, %Nick = $2, %Target = $3, %Type = $4-
  if (%ExploitAlert) echo 4 -ae *** %Nick sent an exploit to %Target ( $+ %Type $+ )
  if (%ExploitLog) ExploitLogQueue %Mask %Target %Type
  if ((%ExploitKick) || (%ExploitExpose)) {
    var %i = 1
    while ($comchan(%Nick, %i)) {
      var %Channel = $ifmatch
      if ($me isop %Channel) {
        if (%ExploitKick) ExploitKickQueue %Channel %Nick %Type
        elseif (%ExploitExpose) ExploitExposeQueue %Channel %Nick %Type
      }
      elseif (%ExploitExpose) ExploitExposeQueue %Channel %Nick %Type
      inc %i
    }
  }
  if (%ExploitWarn) ExploitWarnQueue %Nick
}

; -- Add an exploit logging to the command queue.  ExploitLog <hostmask> <target> <exploit name>
alias -l ExploitLogQueue CommandQueue add 300 1 $+($1, .ExploitLog) 1 InitiateExploitLog $1-

; -- Add an exploit kicking to the command queue.  ExploitKick <channel> <nickname> <exploit name>
alias -l ExploitKickQueue CommandQueue add -n 15 1 $+($1, $chr(1), $2, .ExploitKick) 1 ban -ku3600 $1-2 2 One hour ban -- Lamer kick ( $+ $3- exploit)

; -- Add an exploit exposing to the command queue.  ExploitExposeQueue <channel> <nick> <exploit type>
alias -l ExploitExposeQueue CommandQueue add 30 3 $+($1, $chr(1), $2, .ExploitExpose) 1 $+($1, .ExploitExpose) 5 ExploitExpose 50 msg $1 $2 is a lamer ( $+ $3- exploit)

; -- Add an exploiter warning to the command queue.  ExploitWarnQueue <nick>
alias -l ExploitWarnQueue CommandQueue add 30 2 $+($1, .ExploitWarn) 1 ExploitWarn 7 notice $1 Please do not exploit me.

; -- Flood-preventing command queue
;    Usage: CommandQueue add [options] <flood timeout> <number of flood checks> [<check 1 name> <check 1 limit> ... <check n name> <check n limit>] <command>
;           Option n (no reset) doesn't reset the timeout for a flood check each time the check is hit.  This allows you to block a flood for a certain amount of time from the first
;             hit, rather than an amount of time from the last hit.
;    Notes: The order you put the checks in is important: if check 1 already stopped an earlier queue addition and it hasn't timed out, only check 1 will be updated, not any checks
;             after check 1.  This allows you to, for instance, report up to five members of a group of attackers to a channel without allowing the first attacker to hit the
;             number-of-attackers check by himself.  He'll hit the check for an individual attacker and be stopped from hitting any other checks in future queue addition attempts.
alias CommandQueue {
  var %HashName = $+(Queue., $cid, .Command), %Action = $1
  if (%Action == add) {
    var %Options
    if ($2 isnum) tokenize 32 $2-
    else {
      set %Options $2
      tokenize 32 $3-
    }

    var %ResetTime = $1, %Checks = $gettok($3-, $+(1-, $calc(2 * $2)), 32), %Command = $gettok($3-, $+($calc(2 * $2 + 1), -), 32)
    var %Allow = $true, %i = 1
    while ($gettok(%Checks, $+($calc(2 * %i - 1), -, $calc(2 * %i)), 32)) {
      var %CheckKey = $+(Check., $gettok($ifmatch, 1, 32)), %CheckLimit = $gettok($ifmatch, 2, 32), %ItemTimeout = $iif((n isin %Options) && ($hget(%HashName, %CheckKey).unset), $hget(%HashName, %CheckKey).unset, %ResetTime)
      if ($hget(%HashName, %CheckKey) > %CheckLimit) {
        var %Allow = $false
        hinc $+(-mu, %ItemTimeout) %HashName %CheckKey
      }
      if (!%Allow) break
      inc %i
    }
    if (%Allow) {
      var %i = 1
      while ($gettok(%Checks, $+($calc(2 * %i - 1), -, $calc(2 * %i)), 32)) {
        var %CheckKey = $+(Check., $gettok($ifmatch, 1, 32)), %CheckLimit = $gettok($ifmatch, 2, 32), %ItemTimeout = $iif((n isin %Options) && ($hget(%HashName, %CheckKey).unset), $hget(%HashName, %CheckKey).unset, %ResetTime)
        if ($hget(%HashName, %CheckKey) >= %CheckLimit) var %Allow = $false
        hinc $+(-mu, %ItemTimeout) %HashName %CheckKey
        inc %i
      }
      if (%Allow) {
        var %i = 1
        while ($hget(%HashName, $+(Command., %i))) inc %i
        hadd -m %HashName $+(Command., %i) %Command
        if (!$timer($+(QueueTimer., $cid))) QueueTimer
      }
    }
  }
  elseif (%Action == next) {
    var %CommandKey = $hfind(%HashName, Command.*, 1, w)
    if (%CommandKey) {
      $($hget(%HashName, %CommandKey), 2)
      hdel %HashName %CommandKey
    }
    elseif ($timer($+(QueueTimer., $cid))) QueueTimerStop
  }
}

; -- Start the timer to execute the command queue
alias -l QueueTimer .timerQueueTimer. $+ $cid -m 0 250 CommandQueue next

; -- Stop the command queue timer
alias -l QueueTimerStop .timerQueueTimer. $+ $cid off




; *** LOGGING SECTION ***

; -- Start a whois log
alias -l InitiateExploitLog {
  var %Mask = $1, %Nick = $gettok(%Mask, 1, 33), %Target = $2, %Type = $3-
  hadd -m $+(ExploitLog., $cid) %Mask %Nick %Mask (on $network $+ ) sent an exploit to %Target ( $+ %Type $+ )
  whois %Nick
}

; -- Start logging, whois results are arriving (put this above the raw * logging handler)
raw 311:*:{
  var %HashName = $+(ExploitLog., $cid), %Mask = $+($2, !, $3, @, $4)
  if ($hget(%HashName, %Mask)) {
    var %FirstLogMessage = $gettok($ifmatch, 2-, 32)
    hadd -m %HashName active %Mask
    LogExploit %FirstLogMessage
    LogExploit $numeric $1-
  }
}

; -- Log that positive whois results aren't coming (put this above the raw * logging handler)
raw 401:*:{
  var %HashName = $+(ExploitLog., $cid), %Nick = $2, %i = 1
  while ($hfind(%HashName, $+(%Nick, !*), %i, w)) {
    var %FirstLogMessage = $gettok($hget(%HashName, $ifmatch), 2-, 32)
    LogExploit %FirstLogMessage
    LogExploit $numeric $1-
    LogExploit ---
    inc %i
  }
  hadd -m %HashName active $false
}

; -- Stop logging, whois results are ending (put this above the raw * logging handler)
raw 318:*:{
  var %HashName = $+(ExploitLog., $cid)
  if ($hget(%HashName, active)) {
    LogExploit ---
    hdel %HashName $hget(%HashName, active)
  }
  hadd -m %HashName active $false
}

; -- Keep logging, whois results are still coming
raw *:$($me $iif($hget($+(ExploitLog., $cid), active), $gettok($ifmatch, 1, 33), $false) *):LogExploit $numeric $1-

; -- Do the actual work of logging
alias -l LogExploit {
  if (!$window(@ExploitLog)) window -ek0n @ExploitLog
  echo 6 @ExploitLog $1-
}




; *** RAW WINDOW SECTION ***

; -- Turn on a raw window (with exploit protection) for this server
alias RawWin {
  window -ek0mnv $+(@Raw-, $cid)
  .debug -inpt $+(@Raw-, $cid) DebugExploitWatcher
  if ($show) window -a $+(@Raw-, $cid)
}

; -- Allow saving of raw window buffer
menu @Raw-* {
  Save past raw text to log file:{
    var %i = 1, %file = $sfile($logdir $+ *.log, Save As, Save)
    %file = $+($chr(34), $iif($chr(46) isin %file, %file, %file $+ .log), $chr(34))
    if (%file != $null) {
      while (%i <= $line($active, 0)) {
        write %file $line($active, %i)
        inc %i
      }
    }
  }
}

; -- Send things typed into raw window to the server as raw text
on *:INPUT:@Raw-*:{
  if ($left($gettok($1-, 1 ,32), 1) != $chr(47)) {
    scid $cid .raw $1-
    haltdef
  }
}

; -- Keep protecting when the raw window is closed
on *:CLOSE:@Raw-*:InvisibleProtection




; *** SETTINGS WINDOW SECTION ***

; -- It's not yet a firewall, so call it an exploit fix
alias ExploitFixSettings FirewallSettings

; -- Open the settings window
alias FirewallSettings dialog -m FirewallSettings FirewallSettings

; -- Correctly set up the settings window
on *:dialog:FirewallSettings:init:*:{
  var %Options = $FirewallOptions
  var %i = 1
  while ($gettok(%Options, %i, 32)) {
    var %Option = $ifmatch
    did $iif($($gettok(%Option, 2, 44), 2), -c, -u) $dname $gettok(%Option, 1, 44)
    inc %i
  }
}

; -- Save changed settings
on *:dialog:FirewallSettings:sclick:*:{
  if ($istok(1001 1002, $did, 32)) {
    var %RawWindowsBefore = %RawWindows
    var %Options = $FirewallOptions
    var %i = 1
    while ($gettok(%Options, %i, 32)) {
      var %Variable = $gettok($ifmatch, 2, 44), %State = $did($dname, $gettok($ifmatch, 1, 44)).state
      if (%State) set $(%Variable) $true
      else unset $(%Variable)
      inc %i
    }
    set %ExploitSetUp $true
    if ((%RawWindows) && (!%RawWindowsBefore)) scid -a .RawWin
    SaveFirewallData
  }
}

; -- Return which variables settings are stored in
alias -l FirewallOptions {
  var %Options
  set %Options %Options 201,%ExploitAlert
  set %Options %Options 202,%ExploitWarn
  set %Options %Options 203,%ExploitLog
  set %Options %Options 204,%ExploitKick
  set %Options %Options 205,%ExploitExpose
  set %Options %Options 301,%RawWindows
  return %Options
}

; -- Return firewall version
alias FirewallVersion {
  ; Find the version number in this script file
  var %VersionLine = $read($script, nt, 4), %Version = $gettok(%VersionLine, $calc($findtok(%VersionLine, version, 1, 32) + 1), 32)
  ; Remove the dot at the end (2.0. => 2.0)
  .echo -q $regex(%Version, /^(.*[^.])\.?$/)
  ; Return the version number
  return $regml(1)
}

; -- Return firewall name
alias -l FirewallName {
  ; Find the name in this script file
  var %VersionLine = $read($script, nt, 4)
  return $gettok(%VersionLine, $+(2-, $calc($findtok(%VersionLine, version, 1, 32) - 1)), 32)
}

; -- Generate the code for the settings dialog table (to allow me to change it quickly)
alias FirewallSettingsDialogGenerator {
  var %OptionSeparator = 94, %ParameterSeparator = 44
  var %Width = 180, %YOffset = 10, %Options

  ;  set %Options %Options $+ header,10,Protection level^
  ;  set %Options %Options $+ text,11,Note: Changes to the protection level will disconnect then reconnect you to IRC.^
  ;  set %Options %Options $+ radio,101,Maximum^
  ;  set %Options %Options $+ radio,102,Minimum^
  ;  set %Options %Options $+ space^
  set %Options %Options $+ header,20,Lamer handling^
  set %Options %Options $+ check,201,Alert me in the active window^
  set %Options %Options $+ check,202,Warn exploiter^
  set %Options %Options $+ check,203,Log exploiter's /whois information^
  set %Options %Options $+ check,204,Expose the exploiter on the channels both I and the exploiter are on^
  set %Options %Options $+ check,205,Kick-ban the exploiter on channels with the exploiter where I am an op^
  set %Options %Options $+ space^
  set %Options %Options $+ header,30,Raw windows^
  set %Options %Options $+ check,301,Automatically open raw windows^

  set %Options %Options $+ space
  linesep -a
  echo 6 -a dialog -l FirewallSettings $chr(123)
  echo 6 -a $chr(2) $chr(2) title Settings for Olathe's $!FirewallName $!FirewallVersion
  echo 6 -a $chr(2) $chr(2) size -1 -1 $calc(%Width + 20) $calc(10 * ($numtok(%Options, %OptionSeparator) + 2) + 10)
  echo 6 -a $chr(2) $chr(2) option dbu

  var %i = 1
  echo 6 -a $chr(2)
  while ($gettok(%Options, %i, %Optionseparator)) {
    var %Option = $ifmatch
    if (%Option == space) echo 6 -a $chr(2)
    elseif ($gettok(%Option, 1, %ParameterSeparator) == header) echo 6 -a $chr(2) $chr(2) text " $+ $gettok(%Option, 3-, %ParameterSeparator) $+ ", $gettok(%Option, 2, %ParameterSeparator) $+ , 10 $calc(10 * (%i - 1) + %YOffset) %Width 7, center
    else echo 6 -a $chr(2) $chr(2) $gettok(%Option, 1, %ParameterSeparator) " $+ $gettok(%Option, 3-, %ParameterSeparator) $+ ", $gettok(%Option, 2, %ParameterSeparator) $+ , 10 $calc(10 * (%i - 1) + %YOffset) %Width 7
    inc %i
  }

  var %ButtonWidth = $int($calc((%Width / 3) - 5))
  echo 6 -a $chr(2) $chr(2) button "OK", 1001, 10 $calc(10 * (%i - 1) + %YOffset) %ButtonWidth 14, Default, OK
  echo 6 -a $chr(2) $chr(2) button "Apply", 1002, $int($calc(10 + ((%Width - %ButtonWidth) / 2))) $calc(10 * (%i - 1) + %YOffset) %ButtonWidth 14
  echo 6 -a $chr(2) $chr(2) button "Cancel", 1003, $calc(10 + %Width - %ButtonWidth) $calc(10 * (%i - 1) + %YOffset) %ButtonWidth 14, Cancel
  echo 6 -a $chr(125)
  linesep -a
}

; -- The settings dialog table
dialog -l FirewallSettings {
  title Settings for Olathe's $FirewallName $FirewallVersion
  size -1 -1 200 130
  option dbu

  text "Lamer handling", 20, 10 10 180 7, center
  check "Alert me in the active window", 201, 10 20 180 7
  check "Warn exploiter", 202, 10 30 180 7
  check "Log exploiter's /whois information", 203, 10 40 180 7
  check "Expose the exploiter on the channels both I and the exploiter are on", 204, 10 50 180 7
  check "Kick-ban the exploiter on channels with the exploiter where I am an op", 205, 10 60 180 7

  text "Raw windows", 30, 10 80 180 7, center
  check "Automatically open raw windows", 301, 10 90 180 7

  button "OK", 1001, 10 110 55 14, Default, OK
  button "Apply", 1002, 72 110 55 14
  button "Cancel", 1003, 135 110 55 14, Cancel
}
